#ifndef rangeset_fn_h_DEFINED
#define rangeset_fn_h_DEFINED

#include "rangeset.h"

void RangesetRefreshRange(Rangeset *p, int start, int end);
void RangesetEmpty(Rangeset *r);
void RangesetInit(Rangeset *r, char label, textBuffer *buf);
int RangesetChangeModifyResponse(Rangeset *r, char *name);
int RangesetFindRangeNo(Rangeset *p, int ind, int *start, int *end);
int RangesetFindRangeOfPos(Rangeset *p, int pos, int incl_end);
int RangesetCheckRangeOfPos(Rangeset *p, int pos);
int RangesetInverse(Rangeset *p);
int RangesetAdd(Rangeset *p, Rangeset *q);
int RangesetAddBetween(Rangeset *p, int start, int end);
int RangesetRemove(Rangeset *p, Rangeset *q);
int RangesetRemoveBetween(Rangeset *p, int start, int end);
int RangesetGetNRanges(Rangeset *p);
void RangesetSetMaxpos(Rangeset *p, int maxpos);
RangesetTable *RangesetTableAlloc(textBuffer *buf);
RangesetTable *RangesetTableFree(RangesetTable *tab);
int RangesetFindIndex(RangesetTable *tab, char label, int must_be_active);
int RangesetLabelOK(char label);
Rangeset *RangesetForget(RangesetTable *tab, char label);
Rangeset *RangesetFetch(RangesetTable *tab, char label, int make_active);
void RangesetTableClearMacroVars(RangesetTable *tab);
void RangesetTableAssignMacroVars(RangesetTable *tab, Rangeset *p, int range);
char *RangesetTableGetMacroSetLabel(RangesetTable *tab);
int RangesetTableGetMacroRangeIndex(RangesetTable *tab);
int RangesetTableGetMacroRangeStart(RangesetTable *tab);
int RangesetTableGetMacroRangeEnd(RangesetTable *tab);
int RangesetTableGetMacroRangeN(RangesetTable *tab);
char *RangesetTableGetMacroRangeList(RangesetTable *tab);
char *RangesetTableGetMacroRangeColor(RangesetTable *tab);
char *RangesetTableGetMacroRangeModify(RangesetTable *tab);
void RangesetTableUpdatePos(RangesetTable *tab, int pos, int n_ins, int n_del);
void RangesetBufModifiedCB(int pos, int nInserted, int nDeleted, int nRestyled,
	char *deletedText, void *cbArg);
int RangesetIndex1ofPos(RangesetTable *tab, int pos, int needs_color);
int RangesetAssignColorName(Rangeset *p, char *color_name);
int RangesetAssignColorPixel(Rangeset *p, Pixel color, int ok);
char *RangesetGetColorName(Rangeset *p);
int RangesetGetColorValid(Rangeset *p, Pixel *color);
char *RangesetTableGetColorName(RangesetTable *tab, int ind);
int RangesetTableGetColorValid(RangesetTable *tab, int ind, Pixel *color);
int RangesetTableAssignColorPixel(RangesetTable *tab, int ind, Pixel color,
	int ok);

#endif /* rangeset_fn_h_DEFINED */
